﻿using System.Web.Mvc;
using System.Web.Routing;

namespace MvcApplication2.Controllers
{
    public class MyUserBinder : DefaultModelBinder
    {
        public override object BindModel(ControllerContext controllerContext, ModelBindingContext bindingContext)
        {
            var value = bindingContext.ValueProvider.GetValue(bindingContext.ModelName);

            if (value == null)
                return null;

            var intValue = value.ConvertTo(typeof(int?)) as int?;
            if (intValue == null)
                return null;

            return new MyUser() { Id = intValue.Value };
        }
    }
    public class MyUserUnbinder : IModelUnbinder<MyUser>
    {
        public void UnbindModel(RouteValueDictionary routeValueDictionary, string routeName, MyUser routeValue)
        {
            if (routeValue != null)
                routeValueDictionary.Add(routeName, routeValue.Id);
        }
    }
    public class MyUser
    {
        public int Id { get; set; }
    }

    public partial class HomeController : Controller
    {
        //
        // GET: /Home/

        public virtual ActionResult Index()
        {
            return View();
        }

        public virtual ActionResult Tst(MyUser user)
        {
            user = user ?? new MyUser() { Id = 1 };
            return Content(user.Id.ToString());
        }

    }
}
